HDU 3466 Proud Merchants(某种顺序下的背包)

Proud Merchants

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)
Total Submission(s): 3889    Accepted Submission(s): 1629


Problem Description
Recently, iSea went to an ancient country. For such a long time, it was the most wealthy and powerful kingdom in the world. As a result, the people in this country are still very proud even if their nation hasn’t been so wealthy any more.
The merchants were the most typical, each of them only sold exactly one item, the price was Pi, but they would refuse to make a trade with you if your money were less than Qi, and iSea evaluated every item a value Vi.
If he had M units of money, what’s the maximum value iSea could get?

 

Input
There are several test cases in the input.

Each test case begin with two integers N, M (1 ≤ N ≤ 500, 1 ≤ M ≤ 5000), indicating the items’ number and the initial money.
Then N lines follow, each line contains three numbers Pi, Qi and Vi (1 ≤ Pi ≤ Qi ≤ 100, 1 ≤ Vi ≤ 1000), their meaning is in the description.

The input terminates by end of file marker.

 

Output
For each test case, output one integer, indicating maximum value iSea could get.

 

Sample Input
  
  
2 10 10 15 10 5 10 5 3 10 5 10 5 3 5 6 2 7 3
 

Sample Output
  
  
5 11
 

Author
iSea @ WHU
 

Source

题意:首先给出物品数量和手中资金

人后每样物品给出价格,需要购买时手中至少需要多少资金,还有物品本身的价值

要求求出最大资金



这道题看了解题报告后才懂的,第一次遇到这种变形的背包,不过真是很难想到要先按照Q-P排序。。。
 
下面说一下我对本题的理解。
 
     首先讲一下暴力解决,很显然我们可以用枚举的方法,对每个物品都有选与不选两种决策。但即使暴力也存在一个问题,比如对 3 5 6,5 10 5这两个物品,如果我们的决策是两个都不选或者是只选其中一个,显然没什么问题,但如果我们要是两个都选的话,按照之前这个顺序有m>=13,但如果把两个的顺序交换一下则m>=10即可,从这里就可以看出问题的所在了。于是,对任意两个物品i,j,为了避免上面存在的那种问题,我们可以算出两种顺序所需要的最少金额,若i->j,则至少需要Pi+Qj,若是j->i则至少需要Pj+Qi。如果已知结果是i->j较优的话,则有Pi+Qj<Pj+Qi,即Qi-Pi>Qj-Pj。所以若对之前的物品先按照Q-P由大到小排好序后,然后暴力就可以解决了。但这种暴力其实已有较好的算法可以解决了,即0-1背包,说到这里原问题就已经完全转化为了普通的0-1背包了
 
    但还有一点需要要解释一下,刚才是说暴力是按照Q-P从大到小先排好序,但由于dp与暴力其实正好是两个逆过程,dp的好处就不再多解释了,即避免对子问题的重复计算。所以dp前我们是按照Q-P从小到大的顺序排好序。
 
OK,此题总算完满解决了!

#include<stdio.h>
#include<iostream>
#include<string>
#include<string.h>
#include<cstdlib>
#include<algorithm>
#include<map>
#include<cmath>
#include<stack>
#include<queue>
#include<set>
#include<vector>
#define F first
#define S second
#define PI acos(-1.0)
#define E  exp(1.0)
#define INF 0xFFFFFFF
#define MAX -INF
#define len(a) (__int64)strlen(a)
#define mem0(a) (memset(a,0,sizeof(a)))
#define mem1(a) (memset(a,-1,sizeof(a)))
using namespace std;
__int64 gcd(__int64 a, __int64 b) {
    return b ? gcd(b, a % b) : a;
}
__int64 lcm(__int64 a, __int64 b) {
    return a / gcd(a, b) * b;
}
int max(int a, int b) {
    return a > b ? a : b;
}
__int64 min(__int64 a, __int64 b) {
    return a < b ? a : b;
}
struct pp
{
	int p,q,v;
};
pp w[510];
int dp[5010];
bool cmp(pp a,pp b)
{
	return a.q-a.p<b.q-b.p;
}
int main() {
//    freopen("in.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
    int n,m;
    while (scanf("%d%d", &n, &m) != EOF) {
       for(int i=1;i<=n;i++)
       {
    	   scanf("%d%d%d",&w[i].p,&w[i].q,&w[i].v);
       }
       mem0(dp);
       sort(w+1,w+n+1,cmp);
       for(int i=1;i<=n;i++)
       {
    	   for(int j=m;j>=w[i].q;j--)
    	   {
    			   dp[j]=max(dp[j],dp[j-w[i].p]+w[i].v);
    	   }
       }
       printf("%d\n",dp[m]);
    }
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值